// SpriteContainer.h: sprite_container NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////
// 2001/04/04 \[X𕪗
// 2001/04/05 ev[g
// 2001/04/11 begin() ̃oOC
// 2001/06/15 group -> layer ɕύX
// 2001/06/15 Rgt܂

#if !defined(AFX_SPRITECONTAINER_H__C776DDD9_040F_41CF_92F8_D1C3EAC5C60F__INCLUDED_)
#define AFX_SPRITECONTAINER_H__C776DDD9_040F_41CF_92F8_D1C3EAC5C60F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////
// sprite_container
//

template< class _T, class _CSpr = list<_T*>, class _ILay = int, class _CLay = vector<_CSpr> >
class sprite_container
{
public:
	// Rei̒`
	typedef _CSpr container;		// CRei
	typedef _CLay layer_container;	// CSRei
	typedef _T  * value_type;		// vf̒l^
	typedef _ILay layer_selector;	// CIq^

	// Ce[^̊{`
	typedef container::iterator sprite_iterator;		// C̔q
	typedef layer_container::iterator layer_iterator;	// CS̔q

	// q
	class iterator
	{
	private:
		// q͈͓ɗ}
		void forward_bounding()
		{
			if( (*m_itLay).end() == m_itSpr )
			{
				m_itLay++;

				if( m_itLay == m_itEnd )
				{
					m_itSpr = NULL;
					return;
				}

				if( (*m_itLay).empty() )
				{
					m_itSpr = (*m_itLay).end();
					forward_bounding();
				}
				else
					m_itSpr = (*m_itLay).begin();
			}
		};

	public:
		// STL q`
		typedef forward_iterator_tag iterator_category;
		typedef _T * value_type;
		typedef ptrdiff_t distance_type;

		// \zq
		iterator()
			: m_itLay(NULL), m_itSpr(NULL), m_itEnd(NULL) {};

		// \zq
		iterator( layer_iterator & _XLay, sprite_iterator & _XSpr, layer_iterator & _XEnd )
			: m_itLay(_XLay), m_itSpr(_XSpr), m_itEnd(_XEnd) {};

		// Ԑ
		_T * operator*() const
		{ return *m_itSpr; };

		// OuCNg
		iterator & operator++()
			{ ++m_itSpr; forward_bounding(); return *this; };

		// uCNg
		iterator operator++(int)
			{ iterator _Tmp = *this; ++(*this); return _Tmp; };

		// r
		bool operator==( const iterator & _X ) const
			{ return m_itSpr == _X.m_itSpr; };

		// Ȃr
		bool operator!=( const iterator & _X ) const
			{ return m_itSpr != _X.m_itSpr; };

	protected:
		layer_iterator  m_itLay;	// JgCw
		sprite_iterator m_itSpr;	// m_itLaỹJgXvCgw
		layer_iterator  m_itEnd;	// IC

		friend class sprite_container<_T,_CSpr,_ILay,_CLay>;
	};
	typedef const iterator const_iterator;

	// Ŏq
	~sprite_container() { clear_all(); };

	// Ŝ̐擪
	iterator begin()
	{
		layer_iterator gbegin = m_sp.begin();
		layer_iterator gend = m_sp.end();
		while( gbegin != gend )
		{
			if( (*gbegin).empty() )
				gbegin++;
			else
				break;
		}
		return iterator( gbegin, (*gbegin).begin(), gend );
	};

	// Ŝ̖
	iterator end()
	{
		layer_iterator gend = m_sp.end();
		return iterator( gend, sprite_iterator(NULL), gend );
	};

	// w背C̐擪
	iterator begin( layer_selector iLay )
	{
		layer_iterator gbegin = &m_sp.at(iLay);					// ȁH
		return iterator( gbegin, (*gbegin).begin(), ++gbegin );
	};

	// w背C̖
	iterator end( layer_selector iLay )
	{
		layer_iterator gend = &m_sp.at(iLay);
		sprite_iterator send;
		if( gend == m_sp.end() )
			send = NULL;
		else
			send = (*gend).begin();
		return iterator( gend, send, gend );
	};

	friend class sprite_container<_T,_CSpr,_ILay,_CLay>::iterator;

	// vf̒ǉ
	void add( layer_selector nLay, _T * sp )
	{ m_sp.at(nLay).push_back(sp); };

	// vf̍폜
	iterator erase( iterator it )
	{
		it.m_itSpr = (*it.m_itLay).erase(it.m_itSpr);
		return it;
	};
	
	// Svf̍폜
	void clear_layer( layer_selector nLay )
	{
		sprite_iterator it;
		for( it = m_sp.at(nLay).begin() ; it != m_sp.at(nLay).end() ; it++ )
			delete *it;
		m_sp.at(nLay).clear();
	};

	// w背C̗vfSč폜
	void clear_layer( layer_iterator & itrLay )
	{
		sprite_iterator it;
		for( it = (*itrLay).begin() ; it != (*itrLay).end() ; it++ )
			delete *it;
		(*itrLay).clear();
	};

	// Svf̍폜
	void clear_all()
	{
		layer_iterator it;
		for( it = m_sp.begin() ; it != m_sp.end() ; it++ )
			clear_layer(it);
		m_sp.clear();
	};

	// C̓ւ
	void swap( layer_selector nLay1, layer_selector nLay2 )
	{ m_sp.at(nLay1).swap(m_sp.at(nLay2)); };

	// C̕ύX
	void resize( layer_selector n ) { m_sp.resize(n); };

	// \[gigreater<_T*>gpj
	void sort()
	{
		layer_iterator itLay;
		for( itLay = m_sp.begin() ; itLay != m_sp.end() ; itLay++ )
		{
			greater<_T*> gt;
			(*itLay).sort(gt);
		}
	};

	// SCŗvf󂩂ǂ
	bool empty() const
	{
		if( m_sp.empty() )
			return true;
		for( layer_selector i = 0 ; i != m_sp.size() ; i++ )
		{
			if( ! m_sp.at(i).empty() )
				return false;
		}
		return true;
	};

	// SC̗vf̎擾
	size_t total_size() const
	{
		if( m_sp.size() == 0 )
			return 0;
		size_t sz = 0;
		for( layer_selector i = 0 ; i != m_sp.size() ; i++ )
			sz += m_sp.at(i).size();
		return sz;
	};

	// C̎擾
	size_t layer_size() const
	{ return m_sp.size(); };

	// oϐ
protected:
	layer_container m_sp;
};

#endif // !defined(AFX_SPRITECONTAINER_H__C776DDD9_040F_41CF_92F8_D1C3EAC5C60F__INCLUDED_)
